package calc;

import java.util.HashSet;
import java.util.Set;

public class Parenthesis extends Expression {
	private static final int LEVEL_UNSET = -2;

	public Parenthesis(int i) {
		super(i);
	}

	@Override
	public double accept(String expression) {
		Set<String> parens = new HashSet<>();
		int level = -2;
		int pos = 0;
		int last = -1;
		for(char c : expression.toCharArray()) {
			if(c == '(') {
				if(level == LEVEL_UNSET)
					level = 0;
				level++;
				if(level == 1)
					last = pos;
			} else if(c == ')') {
				level--;
			}
			if(level == 0) {
				parens.add(expression.substring(last, pos + 1));
				level = LEVEL_UNSET;
			} else if(level == -1) {
				throw new IllegalStateException();
			}
			pos++;
		}
		// Replace the parenthesis and reparse
		for(String parenExpr : parens) {
			String parenContent = parenExpr.substring(1, parenExpr.length() - 1);
			expression = expression.replace(parenExpr, String.valueOf(evaluate(parenContent)));
		}
		return evaluate(expression);
	}
}
